%global gem_name rack-mount

%global testdir %{_tmppath}/%{gem_name}-%{version}

Summary: Stackable dynamic tree based Rack router
Name: rubygem-%{gem_name}
Version: 0.7.1
Release: 5%{?dist}
Group: Development/Languages
License: MIT
URL: http://github.com/josh/%{gem_name}
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
# git clone https://github.com/josh/rack-mount.git && cd rack-mount && git checkout v0.7.1
# tar czvf rack-mount-tests.tgz test/
Source1: %{gem_name}-tests.tgz
# Add dependency on unbundeld regin.
Patch1: rack-mount-add-regin-deps.patch
Requires: ruby(abi) = 1.9.1
Requires: ruby(rubygems)
Requires: rubygem(rack) >= 1.1.0
Requires: rubygem(regin)
BuildRequires: rubygems-devel
BuildRequires: rubygem(rack) >= 1.1.0
BuildRequires: rubygem(regin)
BuildRequires: rubygem(minitest)
BuildArch: noarch
Provides: rubygem(%{gem_name}) = %{version}

%description
Stackable dynamic tree based Rack router. Supports Rack’s X-Cascade convention
to continue trying routes if the response returns pass. This allows multiple
routes to be nested or stacked on top of each other. Since the application
endpoint can trigger the router to continue matching, middle-ware can be used
to add arbitrary conditions to any route. This allows you to route based
on other request attributes, session information, or even data dynamically
pulled from a database.


%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires:%{name} = %{version}-%{release}

%description doc
Documentation for %{name}

%prep
%setup -q -c -T
mkdir -p .%{gem_dir}
gem install --local --install-dir .%{gem_dir} \
            --force %{SOURCE0}

pushd .%{gem_dir}
%patch1 -p0
popd

%build

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

rm -rf %{buildroot}%{gem_libdir}/rack/mount/vendor

%check
rm -rf %{testdir}
mkdir %{testdir}
tar xzvf %{SOURCE1} -C %{testdir}
pushd %{testdir}
testrb -I%{buildroot}%{gem_libdir} -I./test test/test_*
popd
rm -rf %{testdir}


%files
%defattr(-, root, root, -)
%dir %{gem_instdir}
%{gem_libdir}
%doc %{gem_instdir}/LICENSE
%doc %{gem_instdir}/README.rdoc
%exclude %{gem_cache}
%{gem_spec}

%files doc
%defattr(-, root, root, -)
%doc %{gem_docdir}

%changelog
* Tue Jan 24 2012 Vít Ondruch <vondruch@redhat.com> - 0.7.1-5
- Rebuilt for Ruby 1.9.3.

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jun 28 2011 Vít Ondruch <vondruch@redhat.com> - 0.7.1-3
- Relaxed Rack dependency.

* Fri Jun 03 2011 Vít Ondruch <vondruch@redhat.com> - 0.7.1-2
- Fixed missing dependencies after unbundling regin.

* Thu Apr 07 2011 Vít Ondruch <vondruch@redhat.com> - 0.7.1-1
- Updated to rack-mount 0.7.1

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.13-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Jan 28 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-4
- Fixed test execution

* Wed Jan 26 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-3
- Fixed vendor subdirectory removal
- Added test dir cleanup on the beginning of %check section

* Wed Jan 19 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-2
- Added missing prep, build and clean sections
- Added missing dependency on rubygem-rack
- Removed unnecessary cleanup
- Removed vendored Regin and Multimap gems
- Added exection of test suite

* Fri Jan 07 2011 Vít Ondruch <vondruch@redhat.com> - 0.6.13-1
- Initial package
